class Foo {
    public static void main (String[] args) {
	int[] a = {6, 2, 3, -3, 5};
    	int[] b = {6, 2, 3, -3};
	int[] c = {6, 2, 3, -3, 6};
	int[] d = {6, 2, 7, -3, 6};

    	System.out.println("array_sum(a) = "+array_sum(a));
    	System.out.println("array_comp(a, a) = "+array_comp(a, a));
    	System.out.println("array_comp(a, b) = "+array_comp(a, b));
    	System.out.println("array_comp(a, c) = "+array_comp(a, c));
    	System.out.println("array_max(a) = "+array_max(a));
    	System.out.println("array_max(d) = "+array_max(d));

    	int[] e = array_plus(a, c);
    	for (int i=0; i<e.length; i++) {
    	    System.out.println(e[i]);
    	}
    	System.out.println("array_plus(a, b) = "+array_plus(a, b));

    	int[] f = array_reverse(a);
    	for (int i=0; i<e.length; i++) {
    	    System.out.println(f[i]);
    	}

    	array_reverse2(a);
    	for (int i=0; i<e.length; i++) {
    	    System.out.println(a[i]);
    	}
    }

    static int array_sum (int[] x) {
    	int sum=0;
    	for (int i=0; i<x.length; i++) {
    	    sum += x[i];
    	}
    	return sum;
    }

    static boolean array_comp (int[] x, int[] y) {
	if (x.length != y.length) {
    	    return false; // CقȂz
    	}

    	for (int i=0; i<x.length; i++) {
    	    if (x[i]!=y[i]) {
    	    	return false;
    	    }
    	}
	return true;
    }

    static int array_max (int[] x) {
	int max = x[0];
    	for (int i=1; i<x.length; i++) {
    	    if (x[i]>max) {
    	    	max = x[i];
    	    }
    	}
    	return max;
    }

    static int[] array_plus (int[] x, int[] y) {
	if (x.length != y.length) {
    	    return null;
    	}

	int[] z = new int[x.length];
    	for (int i=0; i<x.length; i++) {
    	    z[i] = x[i]+y[i];
    	}
    	return z;
    }

    static int[] array_reverse (int[] x) {
	int[] y = new int[x.length];
    	for (int i=0; i<x.length; i++) {
	    y[i] = x[x.length-i-1];
    	}	
    	return y;
    }

    static void array_reverse2 (int[] x) {
	for (int i=0; i<x.length/2; i++) {
	    swap(x, i, x.length-i-1);
    	}
    }

    static void swap (int[] x, int i, int j) {
	int tmp = x[i]; x[i]=x[j]; x[j]=tmp;
    }
}
