class Cell {
    int  data;
    Cell next;

    int length () {
	if (next==null) {
    	    return 1;
    	} else {
    	    return next.length()+1;
    	}
    }

    void show () {
	if (next==null) {
    	    System.out.println(data);
    	} else {
    	    System.out.print(data+", ");		
    	    next.show();
    	}
    } 

    int sum () {
	if (next==null) {
    	    return data;
    	} else {
    	    return data + next.sum();
    	}
    }

    int max () {
	if (next==null) {
    	    return data;
    	} else {
	    int candidate = next.max();	
	    if (candidate > data) {
    	    	return candidate;
    	    } else {
    	    	return data;
    	    } 
    	}
    }

    private void push_array (int[] a, int i) {
    	a[i] = data;
    	if (next == null) {
    	    return;
    	}
    	next.push_array(a, i+1);
    }

    public int[] to_array () {
    	int[] a = new int[length()];
    	push_array(a, 0);
    	return a;
    }

    public static void main (String[] args) {
    	Cell head=null;	
    	for (int i=0; i<4; i++) {
	    Cell c = new Cell();
	    c.data = i*10;
	    c.next = head;
    	    head = c;
    	}

	System.out.println("head.length() = "+head.length());
    	head.show();
	System.out.println("head.sum() = "+head.sum());
	System.out.println("head.max() = "+head.max());
    	int[] x = head.to_array();
    	for (int i=0; i<x.length; i++) {
    	    System.out.println(x[i]);
    	}
    }
}

