class Node {
    int  data;        // ̃m[hێf[^
    Node left=null;   // ̕؂ւ̎Q
    Node right=null;  // E̕؂ւ̎Q

    /* uleftȉ̔Cӂ̃f[^<= data <=rightȉ̔Cӂ̃f[^v
    	ƂȂ悤ɁCf[^}D                          */
    public void insert (int data) {
    	if (data < this.data) { // ֑}
    	    if (left == null) {
    	    	left = new Node();
    	    	left.data = data;
    	    } else {
    	    	left.insert(data);
    	    }
    	} else {        // E֑}
    	    if (right == null) {
    	    	right = new Node();
    	    	right.data = data;
    	    } else {
    	    	right.insert(data);
    	    }
    	}
    }

    // ؂̍vZ
    public int height () {
    	int left_height=0, right_height=0;
    	if (left != null) {
    	    left_height = left.height();
    	}
    	if (right != null) {
    	    right_height = right.height();
    	}
    	return Math.max(left_height, right_height)+1;
    } 

    public void show (int depth) {
    	if (right!=null) right.show(depth+1);
    	for (int i=0; i<depth; i++) {
    	    System.out.print(" ");
    	}
    	System.out.println(data);
    	if (left!=null) left.show(depth+1);
    }

    public void pre_order () {
    	System.out.println(data);
    	if (left!=null)  left.pre_order();
    	if (right!=null) right.pre_order();
    }

    public void in_order () {
    	if (left!=null)  left.in_order();
    	System.out.println(data);
    	if (right!=null) right.in_order();
    }

    public void post_order () {
    	if (left!=null)  left.post_order();
    	if (right!=null) right.post_order();
    	System.out.println(data);
    }

    public static void main (String[] args) {
    	Node root = new Node();
    	root.data = 10;
    	root.insert(15);
    	root.insert(5);
    	root.insert(12);
    	root.insert(8);
    	root.insert(9);

    	System.out.println(root.height());
    	root.show(0);
    	root.pre_order();
    	root.in_order();
    	root.post_order();
    }
}
