class Foo {
    public static void main (String[] args) {
    	System.out.println(power2(3, 4));
    	System.out.println(power2(3, 0));
    	System.out.println(perm(10, 3));
    	System.out.println(perm(10, 0));
    	System.out.println(sum_interval2(1, 10));
    	System.out.println(sum_interval2(3, 5));
    	System.out.println(sum_interval2(5, 3));
    }

    // a^b = 1 (b==0) or a * a^(b-1) (b>0)
    static int power2 (int a, int b) {
    	if (b==0) {
    	    return 1;
    	} else {
    	    return a*power2(a, b-1);
    	}
    }

    // mPn = 1 (k==0) or n * (n-1)P(k-1)
    static int perm (int n, int k) {
    	if (k==0) {
    	    return 1;
    	} else {
    	    return n*perm(n-1, k-1);
	}
    }

    // m+...+n = 0 (m>n) or m+((m+1)+...+n)
    static int sum_interval2 (int m, int n) {
	if (m>n) {
    	    return 0;
    	} else {
    	    return m+sum_interval2(m+1, n);
    	}
    }
}
