class Fib {
    public static void main (String[] args) {

    	for (int a=0; a<45; a++) {
	    long start = System.currentTimeMillis();
	    int result=fib(a);
	    long end = System.currentTimeMillis();
	    System.out.println("fib("+a+") = "+result+"("+(end-start)+" ms)");
    	}

    	for (int a=0; a<500; a+=20) {
	    long start = System.currentTimeMillis();
	    int result=fib2(a);
	    long end = System.currentTimeMillis();
	    System.out.println("fib2("+a+") = "+result+"("+(end-start)+" ms)");
    	}

    	for (int a=0; a<500; a+=20) {
	    long start = System.currentTimeMillis();
	    int result=fib3(1, 1, a);
	    long end = System.currentTimeMillis();
	    System.out.println("fib3("+a+") = "+result+"("+(end-start)+" ms)");
    	}
    }

    static int fib (int n) {
    	if (n<=1) {
    	    return 1;
    	} else {
    	    return fib(n-1)+fib(n-2);
    	}
    }

    static int fib2 (int n) {
    	int previous=1, current=1;
    	for (int i=2; i<=n; i++) {
    	    int old_current = current;
    	    current += previous;
    	    previous = old_current;
    	}
    	return current;
    }

    static int fib3 (int previous, int current, int n) {
    	if (n<=0) {
    	    return previous;
    	} else if (n==1) {
    	    return current;
    	} else {
    	    return fib3(current, previous+current, n-1);
    	}
    }
}
