class Cell {
    int  data;	 // ̃Zێf[^
    Cell next;   // ̃Zւ̎Q
    Cell (int data) {
	this.data = data;	
	this.next = null;
    }
    Cell () {} // ̃RXgN^
}

class SortedList {
    private Cell head;

    public SortedList () {
	head = new Cell();
    }

    public void show () {
    	for (Cell p=head.next; p!=null; p=p.next) {
    	    System.out.print(p.data+" ");
    	}	
    	System.out.println();
    }

    public Cell find (int n) {
    	for (Cell p=head.next; p!=null; p=p.next) {
	    if (p.data == n) 
		return p;
	}
	return null;
    }

    public void insert (int n) {
    	Cell new_cell = new Cell();	
    	new_cell.data = n;

	for (Cell p=head; ; p=p.next) {
	    if (p.next==null || new_cell.data < p.next.data) {
		new_cell.next = p.next;
		p.next = new_cell;
		return;
	    }
	}
    }

    public void delete (int n) {
	for (Cell p=head; p.next!=null; p=p.next) {
	    if (n == p.next.data) {
    	    	Cell a = p.next;
		p.next = p.next.next;
		return;
	    }
	}
    }

    public boolean is_sorted () {
	for (Cell p=head.next; p.next!=null; p=p.next) {
    	    if (p.data > p.next.data) {
    	    	return false;
    	    }
    	}
    	return true;
    }

    public static void main (String[] args) {
    	SortedList list = new SortedList(); // VXg𐶐
    	int[] foo = {5, 3, 6, 7, 2, 4, 8, 1, 9, 0};
    	for (int i=0; i<10; i++) {
    	    list.insert(foo[i]);     // f[^10CT[g
    	}
    	list.show();	        // Xg̓e\
    	System.out.println(list.is_sorted());
    	
    	for (int i=0; i<10; i++) {
    	    System.out.println(list.find(i).data);
    	}
    	for (int i=0; i<10; i++) {
    	    list.delete(foo[i]);     // f[^10폜
    	}
    	list.show();	        // Xg̓e\
    }
}
