/* NCbN\[g */
import java.util.*;
class QuickSort {
    public static void main (String[] args) {
        int   seed = 3885;                   // [̎
        int   size = 1000;                   // z̑傫
        int[] data = make_array(size, seed); // zf[^쐬

    	quick_sort(data, 0, data.length-1);  // zf[^NCbN\[g
        print_array(data);                   // \[gʂ\
        if (!is_sorted_array(data)) {        // \[gʂ`FbN
            System.out.println("bad sorted");
        }
    }

    // z񒆂2̃f[^ data[i] data[j]̒lD
    static void swap (int[] data, int i, int j) {
        int tmp=data[i]; data[i]=data[j]; data[j]=tmp;
    }

    // ̑傫 size̔zC seedƂ
    // [ŏD킪ȂΓf[^ƂȂD
    // ̔z\[gf[^ƂĎgpD
    // sizeŊ]ƂĂ̂́Cdf[^邽߂łD
    static int[] make_array (int size, long seed) {
        Random random = new Random(seed);
        int[]  data = new int[size];

        for (int i=0; i<data.length; i++) {
            // 0`size-1 ͈̔͂Ń_Ƀf[^𐶐
            data[i] = Math.abs(random.nextInt()) % size;
        }
        return data;
    }

    // z̒g\郁\bhD\[g̗lqm̂ɕ֗D
    static void print_array (int[] data) {
        for (int i=0; i<data.length; i++) {
            System.out.print(data[i]+" ");
        }
        System.out.println(); // s
    }

    // z dataȂ trueCȂ falseԂ\bhD
    // f[^ɁC\[gʂ`FbN̂ɕ֗D
    static boolean is_sorted_array(int[] data) {
        for (int i=0; i<data.length-1; i++) {
            if (data[i]>data[i+1]) {
                return false;
            }
        }
        return true;
    }

    static void quick_sort (int[] data, int from, int to) {
	if (from>=to) return;        // ͈͂\ɋ΃^[
	int pivot=data[(from+to)/2]; // s{bg^I
	int left=from, right=to;     // p̃CfbNX

	while (left<=right) {
	    while (data[left]<pivot)  left++; // pivotȏT
	    while (data[right]>pivot) right--; // pivotȉT
	    if (left<=right) {
		swap(data, left, right);
		left++; right--;
	    }
	}
	quick_sort(data, from, right); // ċAIɍNCbN\[g
	quick_sort(data, left, to);    // ċAIɉENCbN\[g
    }
}
