/* q[v\[g */
import java.util.*;
class HeapSort {
    public static void main (String[] args) {
        int   seed = 3885;                   // [̎
        int   size = 1000;                   // z̑傫
        int[] data = make_array(size, seed); // zf[^쐬

    	heap_sort(data);      	      	     // zf[^NCbN\[g
        print_array(data);                   // \[gʂ\
        if (!is_sorted_array(data)) {        // \[gʂ`FbN
            System.out.println("bad sorted");
        }
    }

    // z񒆂2̃f[^ data[i] data[j]̒lD
    static void swap (int[] data, int i, int j) {
        int tmp=data[i]; data[i]=data[j]; data[j]=tmp;
    }

    // ̑傫 size̔zC seedƂ
    // [ŏD킪ȂΓf[^ƂȂD
    // ̔z\[gf[^ƂĎgpD
    // sizeŊ]ƂĂ̂́Cdf[^邽߂łD
    static int[] make_array (int size, long seed) {
        Random random = new Random(seed);
        int[]  data = new int[size];

        for (int i=0; i<data.length; i++) {
            // 0`size-1 ͈̔͂Ń_Ƀf[^𐶐
            data[i] = Math.abs(random.nextInt()) % size;
        }
        return data;
    }

    // z̒g\郁\bhD\[g̗lqm̂ɕ֗D
    static void print_array (int[] data) {
        for (int i=0; i<data.length; i++) {
            System.out.print(data[i]+" ");
        }
        System.out.println(); // s
    }

    // z dataȂ trueCȂ falseԂ\bhD
    // f[^ɁC\[gʂ`FbN̂ɕ֗D
    static boolean is_sorted_array(int[] data) {
        for (int i=0; i<data.length-1; i++) {
            if (data[i]>data[i+1]) {
                return false;
            }
        }
        return true;
    }

    static void heap_sort (int[] data) {
	/* 0`(i-1)܂łq[vς݁DiԖڂ̃f[^q[vɑ} */
	for (int i=1; i<data.length; i++) {
	    heap_insert(data, i);
	}
	/* q[v1f[^oD傫ɏoĂD*/
	for (int i=data.length-1; i>0; i--) {
	    swap(data, 0, i);     // ővf data[0] data[i]ƌ
	    downheap(data, 0, i-1); // ćiꂽjq[vC
	}
    }

    /* q[vidata[0]`data[n-1]jɃf[^data[n]} */
    static void heap_insert (int[] data, int n) {
	// eq菬CɓB܂ŌJԂD
	for (int i=n; i>0 && data[i]>data[parent(i)]; i=parent(i)) {
	    swap(data, i, parent(i)); // eqœꊷ
	}
    }

    /* q[v̍m[hfrom݂̂̕sD*/
    static void downheap (int[] data, int from, int to) {
	for (int i=from, j; left(i)<=to; i=j) {
	    j=left(i); 
	    if (right(i)<=to && data[left(i)]<=data[right(i)]) {
		j=right(i);
	    } // ܂ł2̎q̏data[j]ɂȂĂ
	    if (data[j]>data[i]) {  // q̏e傫
		swap(data, i, j);   // 
	    } else {
		return;             // ȂΏI
	    }
	}
    }

    static int left   (int i) { return 2*i+1; }   // ̎q̃CfbNX
    static int right  (int i) { return 2*i+2; }   // E̎q̃CfbNX
    static int parent (int i) { return (i-1)/2; } // ẽCfbNX
}

/*
    tL: s4-2-1.java  s4-2-5.java ܂ŋʕx
          łĂ邪C{1ɂ܂Ƃ߂D܂D
*/
